using System;
using System.IO;
using Avalonia.Controls;
using Avalonia.Threading;
using LibVLCSharp.Avalonia;
using LibVLCSharp.Shared;
using Tesses.CMS.Avalonia;

public class VideoPlayer : Grid
{
    public VideoPlayer()
    {
        view=new VideoView();

        
        
        this.RowDefinitions.Add(new RowDefinition(GridLength.Star));
        this.RowDefinitions.Add(new RowDefinition(GridLength.Auto));
        this.Children.Add(view);
        SetRow(view,0);
        Grid seekPanel = new Grid();
        Button ss=new Button();
        ss.Content = "SS";
        ss.Click += (sender,e)=>{
            //take screenshot
            string realDir=App.Platform.DownloadFilesystem == null ? Environment.GetFolderPath(Environment.SpecialFolder.MyPictures) : Path.Combine(App.Platform.Configuration.DownloadPath,"Screenshots");
            Directory.CreateDirectory(realDir);
            if(MediaPlayer == null) return;
            string name = Path.Combine(realDir,$"TessesCMS-Screenshot-{DateTime.Now.ToString("yyyyMMdd_HHmmss")}-{TimeSpan.FromMilliseconds(MediaPlayer.Position*MediaPlayer.Length).ToString().Replace(":","_")}.png");
            MediaPlayer.TakeSnapshot(0,name,0,0);
            
        };
        slider = new Slider();
        slider.Minimum = 0;
        slider.Maximum = 1000000;
        
        slider.ValueChanged+= (sender,e)=>{
            if(MediaPlayer != null)
            {
                if(!theyareseeking)
                MediaPlayer.Position = (float)(slider.Value/slider.Maximum);
            }
        };
        playBtn=new Button();
        playBtn.Content = "Play";
        playBtn.Click += (sender,e)=>{
            if(MediaPlayer != null)
            {
                if(MediaPlayer.IsPlaying)
                {
                    
                    MediaPlayer.Pause();
                }
                else
                {
                    MediaPlayer.Play();
                }
            }
        };
        seekPanel.ColumnDefinitions.Add(new ColumnDefinition(GridLength.Auto));
        seekPanel.ColumnDefinitions.Add(new ColumnDefinition(GridLength.Star));
        seekPanel.ColumnDefinitions.Add(new ColumnDefinition(GridLength.Auto));
        seekPanel.Children.Add(playBtn);
        seekPanel.Children.Add(slider);
        seekPanel.Children.Add(ss);
        SetColumn(playBtn,0);
        SetColumn(slider,1);
        SetColumn(ss,2);
        this.Children.Add(seekPanel);
        SetRow(seekPanel,1);
    }
    Slider slider;
    Button playBtn;
    VideoView view;
    public MediaPlayer? MediaPlayer 
    {
        get=>view.MediaPlayer;
        set{
            if(view.MediaPlayer != null)
            {
                view.MediaPlayer.Paused -= Paused;
                view.MediaPlayer.Playing -= Playing;
                view.MediaPlayer.PositionChanged -= PositionChanged;
            }
            view.MediaPlayer=value;
            if(view.MediaPlayer != null)
            {
                view.MediaPlayer.Paused += Paused;
                view.MediaPlayer.Playing += Playing;
                view.MediaPlayer.PositionChanged += PositionChanged;
            }
        }
    }



    bool theyareseeking=false;
  

    private void PositionChanged(object? sender, MediaPlayerPositionChangedEventArgs e)
    {
Dispatcher.UIThread.Invoke(()=>{
    theyareseeking=true;
        slider.Value = (e.Position*slider.Maximum);
    theyareseeking=false;
});
    }



    private void Playing(object? sender, EventArgs e)
    {
        Dispatcher.UIThread.Invoke(()=>{
        playBtn.Content="Pause";
        });
    }

    private void Paused(object? sender, EventArgs e)
    {
        Dispatcher.UIThread.Invoke(()=>{
        playBtn.Content="Play";
        });
    }
}