namespace Tesses.CMS.Avalonia.ViewModels.HomePages;

using System;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;
using Tesses.CMS.Avalonia.Models;
using Tesses.CMS.Avalonia.Views.HomePages;
using Tesses.CMS.Client;

public partial class HomeMovieListPageViewModel : ViewModelBase, IBackable
{
    HomeUserPageViewModel homePage;
    public HomeMovieListPageViewModel(HomeUserPageViewModel homePage)
    {
        App.Log("In HomeMovieListPageViewModel::ctor block begin");
        this.homePage = homePage;
        Task.Run(async()=>{
            App.Log("In HomeMovieListPageViewModel::ctor::async block begin");
            
            await foreach(var item in App.Client.Movies.GetMoviesAsync(homePage.Username))
            {
                try{
                _movies.Add(new MovieItem(item,await App.GetMovieThumbnailAsync(homePage.Username,item.Name)));
                }catch(Exception ex)
                {
                    App.Log(ex.ToString());
                }
            }
            App.Log("In HomeMovieListPageViewModel::ctor::async block end");
        }).Wait(0);
        App.Log("In HomeMovieListPageViewModel::ctor block end");
    }

    [ObservableProperty]
    private ObservableCollection<MovieItem> _movies=new ObservableCollection<MovieItem>();
    [ObservableProperty]
    private MovieItem? _selectedListItem;
    partial void OnSelectedListItemChanged(MovieItem? value)
    {
        if (value is null) return;
        SelectedListItem=null;
        //homePage.CurrentPage = new HomeUserPageViewModel(homePage,this,value);
    }

    public ViewModelBase Back()
    {
        return homePage;
    }
    
}