﻿namespace Tesses.CMS.Avalonia.ViewModels;

using System.Collections.ObjectModel;
using System.Linq;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using CommunityToolkit.Mvvm.Messaging;
using Tesses.CMS.Avalonia.Models;

public partial class MainViewModel : ViewModelBase
{
    public MainViewModel(string title)
    {
        _pages.Add(new Page("Settings",()=>new SettingsPageViewModel(this)));
        SelectedListItem = Pages.First();
        this.Title = title;
    }
    [ObservableProperty]
    private bool _paneOpen=true;
    [ObservableProperty]
    private ViewModelBase _currentPage = new HomePageViewModel();

    [ObservableProperty]
    private ObservableCollection<Page> _pages=new ObservableCollection<Page>(){
        new Page("Home",()=>new HomePageViewModel()),
        new Page("Favorites",()=>new FavoritesPageViewModel()),
        new Page("Notifications",()=>new NotificationsPageViewModel()),
        new Page("Downloads",()=>new DownloadsPageViewModel()),
        
    };

    [ObservableProperty]
    private Page? _selectedListItem;
    [ObservableProperty]
    private string _loginText="Login";

    [ObservableProperty]
    private string _title;

     partial void OnSelectedListItemChanged(Page? value)
    {
        if (value is null) return;

        
        

        CurrentPage = value.ViewModel;
    }

    [RelayCommand]
    private void TogglePane()
    {
        PaneOpen = !PaneOpen;
    }
    [RelayCommand]
    private void LoginAccount()
    {
        App.Log("Login button");
    }
}
