using Avalonia;
using Avalonia.Controls;
using Avalonia.Data;
using LibVLCSharp.Shared;

namespace Tesses.CMS.Avalonia.Views;

public class VideoPlayerWrapper : Grid
{
    public VideoPlayerWrapper()
    {
        RowDefinitions.Add(new RowDefinition(GridLength.Star));
        ColumnDefinitions.Add(new ColumnDefinition(GridLength.Star));
        Player= App.Platform.CreatePlayer();
        this.Children.Add(Player);
    }

    public Control Player {get;}

    public MediaPlayer? MediaPlayer 
    {
        get=>App.Platform.GetMediaPlayer(Player);
        set=>App.Platform.SetMediaPlayer(Player,value);
    }


        /// <summary>
        /// MediaPlayer Data Bound property
        /// </summary>
        /// <summary>
        /// Defines the <see cref="MediaPlayer"/> property.
        /// </summary>
        public static readonly DirectProperty<VideoPlayerWrapper, MediaPlayer?> MediaPlayerProperty =
            AvaloniaProperty.RegisterDirect<VideoPlayerWrapper, MediaPlayer?>(
                nameof(MediaPlayer),
                o => o.MediaPlayer,
                (o, v) => o.MediaPlayer = v,
                defaultBindingMode: BindingMode.TwoWay);


}